/*
                        IMTguide.rexx v1.0  31-Oct-94
       Create Texture.guide from Imagine 3.0 texture.txt & litetex.txt
          Sample pics, Guide layout and Inspiration by Randy R. Wall
                          An ARexx hack by D.F. Duck

*/
options results
signal on syntax
signal on break_c

max_wid = 75   /* max chars wide to trim text down to */

if ~show('L',"rexxsupport.library") then do
  if addlib('rexxsupport.library',0,-30,0) then nop
  else do
    say 'Can''t find the rexxsupport.library!'
    exit 10
  end
end

cls='0C'x;nl='0A'x;more=0;icon='Yes';req_wrap=0   /* init a few vars */

call Title
say center('Press CTRL-C at any time to abort.',77)nl
call delay(10)
call Q1
call Q2
call Q3

Edit:
say cls
say ' 1.  Write Texture.guide to  >> 'gui_path
say ' 2.  Move sample pictures to >> 'pic_path
say ' 3.  Your SHOW program is... >> 'show_cmd
say ' 4.  Icon for Texture.guide  >> 'icon
say
say ' Q.  Quit'
say
options prompt ' Number to edit or RETURN to accept. >> '
pull ans
say cls
select
  when ans='' then signal Ask4Disk
  when ans='Q' then signal Die
  when ans=1 then call Q1
  when ans=2 then call Q2
  when ans=3 then call Q3
  when ans=4 then call Q4
  otherwise nop
end
signal Edit

Q1:  /* get user path to write output file to */
options prompt 'Path to write the Texture.guide to.   >> '
parse pull path
if ~exists(path) then do
  options prompt 'Path "'path'" does not exist.  Create it? (Y/n/q)? '
  pull ans
  if ans='Q' then signal Die
  if ans='Y' | ans='' then do
    call makedir(path)
    if ~exists(path) then do
      say 'There seems to be a problem creating "'path'".'
      signal Q1
    end
  end
  if ans='N' then signal Q1
end
if path~='' then gui_path=path
if right(gui_path,1) ~=':' & right(gui_path,1) ~='/' then gui_path=gui_path'/'
return

Q2:  /* get user path to move pic files to */
options prompt 'Path to move the sample pictures to.  >> '
parse pull path
if ~exists(path) then do
  options prompt 'Path "'path'" does not exist.  Create it? (Y/n/q)? '
  pull ans
  if ans='Q' then signal Die
  if ans='Y' | ans='' then do
    call makedir(path)
    if ~exists(path) then do
      say 'There seems to be a problem creating "'path'".'
      signal Q2
    end
  end
  if ans='N' then signal Q2
end
if path~='' then pic_path=path
if right(pic_path,1) ~=':' & right(pic_path,1) ~='/' then pic_path=pic_path'/'
return

Q3:  /* get full path and filename to users SHOW program */
options prompt 'Path & filename of your SHOW program. >> '
parse pull cmd
if ~exists(cmd) then do
  say 'I don''t find 'cmd'. Try again.'
  signal Q3
end
if cmd~='' then show_cmd=cmd
return

Q4: /* toggle icon creation for Texture.guide */
if icon='Yes' then icon='No'
else if icon='No' then icon='Yes'
return

Ask4Disk: /* check for disk - note you don't need to press return! */
call pragma('W','N')       /* turn off requesters */
if ~exists('ram:litetex.txt') then do
  say cls||center('Insert Imagine 3.0 install "DISK1" in any drive.',77)
  do loop = 1
    if exists('DISK1:') then leave loop
  end
  say center('Copying litetex.txt to RAM:',77)
  shell command('copy DISK1:litetex.txt ram:')
end
if ~exists('ram:texture.txt') then do
  say cls||center('Insert Imagine 3.0 install "DISK3" in any drive.',77)
  do loop = 1
    if exists('DISK3:') then leave loop
  end
  say center('Extracting texture.txt to ram:',77)
  old_dir = pragma('D') ; call pragma('D','ram:')
  shell command('DISK3:lharc x DISK3:IM30_3.LZH texture.txt')
  call pragma('D',old_dir) ; drop old_dir
end

say cls||center('Ok, now just sit back for a few minutes while I do my magic.',77)
call delay(120)

/* Move sample pics */
say cls||center('Moving sample pictures to 'pic_path,77)
if ~exists('pics/') then do
  say center('Error: Can''t find the sample pics directory.',77)
  say center('Be sure your current directory is where you unarched IMTguide.lha to.',77)
  options prompt copies(' ',28)'Continue anyway (y/N)? '
  parse pull ans
  if upper(ans) ~='Y' then signal Die
  else signal Main
end
shell command('copy >nil: pics 'pic_path' ALL')
shell command('delete >nil: pics ALL')

Main: /* Open output file for writing, write Main node */
say cls||center('Writing 'gui_path'Texture.guide',77)
say center('Reading ram:texture.txt',77)
call open(y,gui_path'Texture.guide','W')
call writeln(y,'@database Texture.guide'nl'@index TextureAll')
call writeln(y,'@author Created by IMTguide.rexx v1.0 by Randy R. Wall & D.F. Duck'nl)


call node('Main','Imagine 3.0 Texture Guide')
call writeln(y,copies(' ',18)'AmigaGuide For Imagine 3.0 Textures'nl)
call writeln(y,copies(' ',22)'@{"    About This Database    " link "About"}'nl||nl)
call writeln(y,copies(' ',22)'@{"   What Are 3.0 Textures   " link "Textures"}')
call writeln(y,copies(' ',22)'@{" Overall Notes On Textures " link "Notes"}'nl)
call writeln(y,'     @{"    Space Filling Textures   " link "SpaceFilling"}      @{"Specific Application Textures" link "SpecificApplication"}')
call writeln(y,'     @{"         2D Textures         " link "2D_Textures"}      @{"     Animatable Textures     " link "Animatable"}')
call writeln(y,'     @{" Specific Primative Textures " link "SpecificPrims"}      @{"        Fog Textures         " link "Fog"}'nl)
call writeln(y,copies(' ',22)'@{"      Light Textures       " link "Lights"}'nl)
call writeln(y,'     @{"    Texture List  (index)    " link "TextureAll"}      @{"      View Sample Pics       " link "View_Pics"}')
call endnode
call anatine('52656164206D65207769746820416D6967614775696465')

/* open texture.txt file for reading */
call open(x,'RAM:texture.txt','R')

/* Textures node */
line=readln(x)
call node('Textures',strip(line,'T','0D'x))
call waste(1)
count=26 ;call copy_text
call endnode

/* Over all texture notes */
call waste(1)
call node('Notes',strip(readln(x),'T','0D'x))
count=30 ;call copy_text
call endnode
call anatine('546861742052616E647920697320612072617974726163696E67206E757421')

/* Space Filling Textures */
call waste(2)
call node('SpaceFilling',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,3)copies(' ',13)'@{"     Agate      " link "Agate"} @{"    EasyWood    " link "EasyWood"} @{"    Peened      " link "Peened"}')
call writeln(y,copies(' ',13)'@{"    Brushed     " link "Brushed"} @{"     Fakely     " link "Fakely"} @{"    Rainbow     " link "Rainbow"}')
call writeln(y,copies(' ',13)'@{"    BumpNoiz    " link "BumpNoiz"} @{"    FrogSkin    " link "FrogSkin"} @{"    Scratch     " link "Scratch"}')
call writeln(y,copies(' ',13)'@{"    ColorNoiz   " link "ColrNoiz"} @{"     Jersey     " link "Jersey"} @{"    Splotch     " link "Splotch"}')
call writeln(y,copies(' ',13)'@{"    Concrete    " link "Concrete"} @{"    Leather     " link "Leather"} @{"    StainGls    " link "StainGls"}')
call writeln(y,copies(' ',13)'@{"    Confetti    " link "Confetti"} @{"    Marble      " link "Marble"} @{"    Statue      " link "Statue"}')
call writeln(y,copies(' ',13)'@{"    Crumpled    " link "Crumpled"} @{"    Monster     " link "Monster"} @{"     Terra      " link "Terra"}')
call writeln(y,copies(' ',13)'@{"    DinoSkin    " link "DinoSkin"} @{"    Mosaic      " link "Mosaic"} @{"    WormVein    " link "WormVein"}')
call writeln(y,copies(' ',13)'@{"      Dirt      " link "Dirt"} @{"  Noiz2 Family  " link "Noiz2_Family"} @{"    Wrinkle     " link "Wrinkle"}')
call writeln(y,copies(' ',13)'@{"    DrtPaint    " link "DrtPaint"} @{"    Pebbled     " link "Pebbled"} @{"     Zooloo     " link "Zooloo"}')
call endnode
call anatine('517561636B212020517561636B21')

my_arg = '1 Agate 26'		;call write_node
my_arg = '2 Brushed 33'		;call write_node
my_arg = '2 BumpNoiz 23'	;call write_node
my_arg = '2 ColrNoiz 51'	;call write_node
my_arg = '2 Concrete 25'	;call write_node
my_arg = '2 Confetti 37'	;call write_node
my_arg = '2 Crumpled 41'	;call write_node
my_arg = '1 DinoSkin 45'	;call write_node
my_arg = '1 Dirt 25'		;call write_node
my_arg = '2 DrtPaint 29'	;call write_node
my_arg = '2 EasyWood 27'	;call write_node
my_arg = '1 Fakely 24'		;call write_node
my_arg = '2 FrogSkin 30'	;call write_node
my_arg = '2 Jersey 23'		;call write_node
my_arg = '2 Leather 18'		;call write_node
my_arg = '1 Marble 28'		;call write_node
my_arg = '2 Monster 41'		;call write_node
my_arg = '1 Mosaic 38'		;call write_node

/* Noiz2 Family */
call waste(1)
call node('Noiz2_Family',strip(readln(x),'T','0D'x))
call waste(1)
count=27 ;call copy_text
call writeln(y,nl||copies(' ',13)'@{"   ClrNoize2    " link "ClrNoiz2"} @{"    RefNoiz2    " link "RefNoiz2"} @{"    FilNoiz2    " link "FilNoiz2"}')
call endnode
my_arg = '1 ClrNoiz2 2'		;call write_node
my_arg = '1 RefNoiz2 2'		;call write_node
my_arg = '1 FilNoiz2 2'		;call write_node

/* now back to more space filling textures */
my_arg = '1 Pebbled 41'		;call write_node
my_arg = '1 Peened 37'		;call write_node
my_arg = '1 Rainbow 24'		;call write_node
my_arg = '1 Scratch 41'		;call write_node
my_arg = '1 Splotch 26'		;call write_node
my_arg = '2 StainGls 40'	;call write_node
my_arg = '1 Statue 40'		;call write_node
my_arg = '2 Terra 39'		;call write_node
my_arg = '2 WormVein 30'	;call write_node
my_arg = '2 Wrinkle 27'		;call write_node
my_arg = '2 Zooloo 37'		;call write_node

/* 2D Textures */
call waste(3)
call node('2D_Textures',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,4))
call writeln(y,copies(' ',14)'@{"     BathTile     " link "BathTile"}           @{"     Stamped     " link "Stamped"}')
call writeln(y,copies(' ',14)'@{"      Blast       " link "Blast"}           @{"     TriChex     " link "TriChex"}')         
call writeln(y,copies(' ',14)'@{"     BmpBrnch     " link "BmpBrnch"}           @{"      Tracer     " link "Tracer"}')
call writeln(y,copies(' ',14)'@{"     Branches     " link "Branches"}           @{"     TriTile     " link "TriTile"}')
call writeln(y,copies(' ',14)'@{"     Shingles     " link "Shingles"}           @{"      Weave      " link "Weave"}')
call endnode
my_arg = '1 BathTile 48'	;call write_node
my_arg = '2 Blast 31'		;call write_node
my_arg = '2 BmpBrnch 31'	;call write_node
my_arg = '2 Branches 30'	;call write_node
my_arg = '2 Shingles 38'	;call write_node
my_arg = '1 Stamped 39'		;call write_node
my_arg = '2 TriChex 35'		;call write_node
my_arg = '1 Tracer 24'		;call write_node
my_arg = '2 TriTile 29'		;call write_node
my_arg = '2 Weave 36'		;call write_node
call anatine('4D7920666565742061726520666C61742E')

/* Specific Primative Textures */
call waste(3)
call node('SpecificPrims',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,2))
call writeln(y,copies(' ',15)'@{"  Checks Family    " link "Checks_Family"}       @{" DeathStar Family " link "DeathStar_Family"}')
call writeln(y,copies(' ',19)'@{" RectChex " link "RectChex"}                @{" DethStar " link "DethStar"}')
call writeln(y,copies(' ',19)'@{" RadCheks " link "RadCheks"}                @{" RdDthStr " link "RdDthStr"}')
call writeln(y,copies(' ',19)'@{" SprlChex " link "SprlChex"}'nl)
call writeln(y,copies(' ',30)'@{" Plaid Texture " link "Plaid"}'nl)
call writeln(y,copies(' ',15)'@{" Honey Comb Family " link "Honey_Comb_Family"}       @{"  Window Family   " link "Window_Family"}')
call writeln(y,copies(' ',19)'@{" HonyComb " link "HonyComb"}                @{" RadWind  " link "RadWind"}')
call writeln(y,copies(' ',19)'@{" RadComb  " link "RadComb"}                @{" RectWind " link "RectWind"}')
call writeln(y,copies(' ',19)'@{"  Hexez   " link "Hexez"}                @{" TubeWind " link "TubeWind"}')
call endnode

/* Checks Family */
call waste(1)
call node('Checks_Family',strip(readln(x),'T','0D'x':'))
req_wrap=1 ;count=33 ;call copy_text
call writeln(y,nl||copies(' ',9)'@{" RectChex Texture " link "RectChex"} @{" RadCheks Texture " link "RadCheks"} @{" SprlChex Texture " link "SprlChex"}')
call endnode
my_arg = '2 RectChex 18'	;call write_node
my_arg = '1 RadCheks 20'	;call write_node
my_arg = '2 SprlChex 22'	;call write_node

call waste(2)
call node('DeathStar_Family',strip(readln(x),'T','0D'x':'))
count=34 ;call copy_text
call writeln(y,nl||copies(' ',15)'@{" DethStar Texture " link "DethStar"}       @{" RdDthStr Texture " link "RdDthStr"}')
call endnode
my_arg = '2 DethStar 7'		;call write_node
my_arg = '1 RdDthStr 12'	;call write_node

call waste(2)
call node('Honey_Comb_Family',strip(readln(x),'T','0D'x':'))
count=23 ;call copy_text
call writeln(y,nl||copies(' ',13)'@{" HonyComb Texture " link "HonyComb"} @{" Hexez Texture " link "Hexez"} @{" RadComb Texture " link "RadComb"}')
call endnode
my_arg = '2 HonyComb 1'		;call write_node
my_arg = '2 RadComb 1'		;call write_node
my_arg = '2 Hexez 1'		;call write_node

/* Plaid Texture */
my_arg = '2 Plaid 30'		;call write_node

/* Window Family */
call waste(1)
call node('Window_Family',strip(readln(x),'T','0D'x':'))
count=52 ;call copy_text
call writeln(y,nl||copies(' ',8)'@{" RadWind Texture " link "RadWind"} @{" RectWind Texture " link "RectWind"} @{" TubeWind Texture " link "TubeWind"}')           
call endnode
my_arg = '2 RadWind 16'		;call write_node
my_arg = '1 RectWind 11'	;call write_node
my_arg = '1 TubeWind 16'	;call write_node

/* Specific Application Textures */
call waste(3)
call node('SpecificApplication',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,4)copies(' ',16)'@{"    Antique    " link "Antique"}              @{"      Iris      " link "Iris"}')
call writeln(y,copies(' ',16)'@{"    CndyAppl   " link "CndyAppl"}              @{"    LensFlar    " link "LensFlar"}')
call writeln(y,copies(' ',16)'@{"    CoolFir    " link "CoolFir"}              @{"     Metals     " link "Metals"}')
call writeln(y,copies(' ',16)'@{"     Cracks    " link "Cracks"}              @{"    MntnTop     " link "MntnTop"}')
call writeln(y,copies(' ',16)'@{"    DashLine   " link "DashLine"}              @{"     Ribbed     " link "Ribbed"}')
call writeln(y,copies(' ',16)'@{"    FireBall   " link "FireBall"}              @{"    SftStrip    " link "SftStrip"}')
call writeln(y,copies(' ',16)'@{"    GasGiant   " link "GasGiant"}              @{"    Transpar    " link "Transpar"}')
call writeln(y,copies(' ',16)'@{"    HardWood   " link "HardWood"}              @{"    Venitian    " link "Venitian"}')
call writeln(y,copies(' ',16)'@{"    HrdStrip   " link "HrdStrip"}              @{"    Z Buffer    " link "Z_Buffer"}')
call endnode
my_arg = '1 Antique 31'		;call write_node
my_arg = '1 CndyAppl 11'	;call write_node
my_arg = '1 CoolFir 22'		;call write_node
my_arg = '1 Cracks 39'		;call write_node
my_arg = '2 DashLine 37'	;call write_node
my_arg = '2 FireBall 37'	;call write_node
my_arg = '2 GasGiant 53'	;call write_node
my_arg = '1 HardWood 35'	;call write_node
my_arg = '2 HrdStrip 22'	;call write_node
my_arg = '1 Iris 39'		;call write_node
my_arg = '1 LensFlar 29'	;call write_node
my_arg = '1 Metals 26'		;call write_node
my_arg = '1 MntnTop 26'		;call write_node
my_arg = '1 Ribbed 36'		;call write_node
my_arg = '2 SftStrip 33'	;call write_node
my_arg = '1 Transpar 27'	;call write_node
my_arg = '1 Venitian 13'	;call write_node
req_wrap=1
my_arg = '2 Z_Buffer 15'	;call write_node

call waste(27) /* dump the FORMAT: stuff */
call anatine('576861742061206D65737321')

/* Amimatable Textures */ 
call node('Animatable',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,4)copies(' ',31)'@{"  BeamMeUp  " link "BeamMeUp"}')
call writeln(y,copies(' ',31)'@{"  DancSprk  " link "DancSprk"}')
call writeln(y,copies(' ',31)'@{"  DripDrop  " link "DripDrop"}')
call writeln(y,copies(' ',31)'@{"    Rain    " link "Rain"}')
call writeln(y,copies(' ',31)'@{"    Spark   " link "Spark"}')
call writeln(y,copies(' ',31)'@{"   TieDye   " link "TieDye"}')
call endnode
my_arg = '1 BeamMeUp 36'	;call write_node
my_arg = '2 DancSprk 38'	;call write_node
my_arg = '2 DripDrop 27'	;call write_node
my_arg = '2 Rain 41'		;call write_node
my_arg = '2 Spark 27'		;call write_node
my_arg = '2 TieDye 27'		;call write_node

/* Fog Textures */
call waste(3)
call node('Fog',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,4)copies(' ',28)'@{"   Ghost Texture  " link "Ghost"}')
call writeln(y,copies(' ',28)'@{"  FogTop Texture  " link "FogTop"}')
call writeln(y,copies(' ',28)'@{" FogPaint Texture " link "FogPaint"}')
call writeln(y,copies(' ',28)'@{"  Nebula Texture  " link "Nebula"}')
call endnode
my_arg = '1 Ghost 22'		;call write_node
my_arg = '2 FogTop 28'		;call write_node
my_arg = '2 FogPaint 31'	;call write_node
my_arg = '2 Nebula 34'		;call write_node
call anatine('4469727479204475636B20776173206865726521')

call close(x)				/* all done with texture.txt    */
call delete('RAM:texture.txt')

call open(x,'ram:litetex.txt','R')	/* open litetex.txt for reading */
say '1B'x'[2H'center('Reading ram:litetex.txt',77)
/* Light Textures */
call node('Lights',strip(readln(x),'T','0D'x':'))
call writeln(y,copies(nl,5)copies(' ',16)'@{"  FrnchWin - French Windows Light Texture  " link "FrnchWin"}')
call writeln(y,copies(' ',16)'@{"   SoftEdge - Soft Edge Lighting Texture   " link "SoftEdge"}')
call writeln(y,copies(' ',16)'@{"     Strobe - Strobe Lighting Texture      " link "Strobe"}')
call writeln(y,copies(' ',16)'@{" VenLite - Venitian Blind Lighting Texture " link "VenLite"}')
call endnode

call waste(3)
call node('FrnchWin',strip(readln(x),'T','0D'x':'))
req_wrap=1 ;count=17 ;call copy_text
call endnode

call waste(3)
call node('SoftEdge',strip(readln(x),'T','0D'x':'))
req_wrap=1 ;count=12 ;call copy_text
call endnode

call waste(3)
call node('Strobe',strip(readln(x),'T','0D'x':'))
req_wrap=1 ;count=19 ;call copy_text
call endnode

call waste(3)
call node('VenLite',strip(readln(x),'T','0D'x':'))
req_wrap=1 ;count=18 ;call copy_text
call endnode

call close(x)				/* all done with litetex.txt    */
call delete('RAM:litetex.txt')
say '1B'x'[2H'center(' ',77)

/* About */
call node('About','About This Database')
call writeln(y,copies(' ',8)'This AmigaGuide database was created with IMLguide.rexx v1.0')
call writeln(y,copies(' ',10)'Sample pics, Guide layout and Inspiration by Randy R. Wall')
call writeln(y,copies(' ',26)'An ARexx hack by D.F. Duck')
call writeln(y,copies(' ',25)'Beta Tested By: Randy R. Wall'nl||nl)
call writeln(y,' This AmigaGuide database was made to facilitate the proccess of finding')
call writeln(y,' and learning to use the many textures available in Imagine 3.0.')
call writeln(y,' Other people have converted the texture.txt file into AmigaGuide hyper-')
call writeln(y,' text format, but they could not distribute it due to Impulses'' copyright')
call writeln(y,' on the text. But it is perfectly legal to write a program to convert your')
call writeln(y,' legal copy of the text. So, that is what we did.'nl||nl)
call writeln(y,' To discuss raytracing with "RANDY WALL", or ARexx hacking with "DIRTY')
call writeln(y,' DUCK" call -Duck off and Fly- BBS:  916 899-9811  300-14.4k baud.'nl)
call writeln(y,' o AmigaGuide is  Copyright 1990-1993 by;'nl)
call writeln(y,' Commodore-Amiga, Inc.'copies(nl,2))
call writeln(y,' o ARexx is  Copyright 1987 by;'nl)
call writeln(y,'   William S. Hawes   P.O. Box 308   Maynard, MA  01754'nl)
call writeln(y,'   508 568-8695'copies(nl,2))
call writeln(y,' o Imagine 3.0 ,texture.txt & litetex.txt files are  Copyright 1994 by;'nl)
call writeln(y,'   Impulse Inc.  8416 Xerxes Ave. North  Minneapolis, MN  55444'nl)
call writeln(y,'   612 425-0557')
call endnode

/* TextureAll (Index) */
call node('TextureAll','Imagine 3.0 Textures')
call writeln(y,'@{" Noiz2 Fmly " link "Noiz2_Family"} @{" Checks Fmly " link "Checks_Family"} @{" DeathStar Fmly " link "DeathStar_Family"} @{" HoneyComb Fmly " link "Honey_Comb_Family"} @{" WindowFmly " link "Window_Family"}')
call writeln(y,copies(' ',9)'@{" Agate     " link "Agate"} @{" Jersey   " link "Jersey"} @{" Wrinkle  " link "Wrinkle"} @{" CndyAppl " link "CndyAppl"} @{" Transpar " link "Transpar"}')
call writeln(y,copies(' ',9)'@{" Brushed   " link "Brushed"} @{" Leather  " link "Leather"} @{" Zooloo   " link "Zooloo"} @{" CoolFir  " link "CoolFir"} @{" Venitian " link "Venitian"}')
call writeln(y,copies(' ',9)'@{" BumpNoiz  " link "BumpNoiz"} @{" Marble   " link "Marble"} @{" BathTile " link "BathTile"} @{" Cracks   " link "Cracks"} @{" Z Buffer " link "Z_Buffer"}')
call writeln(y,copies(' ',9)'@{" ColorNoiz " link "ColrNoiz"} @{" Monster  " link "Monster"} @{" Blast    " link "Blast"} @{" DashLine " link "DashLine"} @{" BeamMeUp " link "BeamMeUp"}')
call writeln(y,copies(' ',9)'@{" Concrete  " link "Concrete"} @{" Mosaic   " link "Mosaic"} @{" BmpBrnch " link "BmpBrnch"} @{" FireBall " link "FireBall"} @{" DancSprk " link "DancSprk"}')
call writeln(y,copies(' ',9)'@{" Confetti  " link "Confetti"} @{" Pebbled  " link "Pebbled"} @{" Branches " link "Branches"} @{" GasGiant " link "GasGiant"} @{" DripDrop " link "DripDrop"}')
call writeln(y,copies(' ',9)'@{" Crumpled  " link "Crumpled"} @{" Peened   " link "Peened"} @{" Shingles " link "Shingles"} @{" HardWood " link "HardWood"} @{" Rain     " link "Rain"}')
call writeln(y,copies(' ',9)'@{" DinoSkin  " link "DinoSkin"} @{" Rainbow  " link "Rainbow"} @{" Stamped  " link "Stamped"} @{" HrdStrip " link "HrdStrip"} @{" Spark    " link "Spark"}')
call writeln(y,copies(' ',9)'@{" Dirt      " link "Dirt"} @{" Scratch  " link "Scratch"} @{" Tracer   " link "Tracer"} @{" Iris     " link "Iris"} @{" TieDye   " link "TieDye"}')
call writeln(y,copies(' ',9)'@{" DrtPaint  " link "DrtPaint"} @{" Splotch  " link "Splotch"} @{" TriChex  " link "TriChex"} @{" LensFlar " link "LensFlar"} @{" Ghost    " link "Ghost"}')
call writeln(y,copies(' ',9)'@{" EasyWood  " link "EasyWood"} @{" StainGls " link "StainGls"} @{" TriTile  " link "TriTile"} @{" Metals   " link "Metals"} @{" FogTop   " link "FogTop"}')
call writeln(y,copies(' ',9)'@{" Fakely    " link "Fakely"} @{" Statue   " link "Statue"} @{" Weave    " link "Weave"} @{" MntnTop  " link "MntnTop"} @{" FogPaint " link "FogPaint"}')
call writeln(y,copies(' ',9)'@{" FrogSkin  " link "FrogSkin"} @{" Terra    " link "Terra"} @{" Plaid    " link "Plaid"} @{" Ribbed   " link "Ribbed"} @{" Nebula   " link "Nebula"}')
call writeln(y,copies(' ',21)'@{" WormVein " link "WormVein"} @{" Antique  " link "Antique"} @{" SftStrip " link "SftStrip"}')
call endnode

/* View Sample Pics */
cmd=show_cmd' 'pic_path
call node('View_Pics','View Sample Texture Pictures')
call writeln(y,'@{" Noiz2 Fmly " link "Noiz2_View"} @{" Checks Fmly " link "Checks_View"} @{" DeathStar Fmly " link "DeathStar_View"} @{" HoneyComb Fmly " link "HoneyComb_View"} @{" WindowFmly " link "Window_View"}')
call writeln(y,copies(' ',9)'@{" Agate     " system "'cmd'Agate.pic"} @{" Jersey   " system "'cmd'Jersey.pic"} @{" Wrinkle  " system "'cmd'Wrinkle.pic"} @{" CndyAppl " system "'cmd'CndyAppl.pic"} @{" Transpar " system "'cmd'Transpar.pic"}')
call writeln(y,copies(' ',9)'@{" Brushed   " system "'cmd'Brushed.pic"} @{" Leather  " system "'cmd'Leather.pic"} @{" Zooloo   " system "'cmd'Zooloo.pic"} @{" CoolFir  " system "'cmd'CoolFir.pic"} @{" Venitian " system "'cmd'Venitian.pic"}')
call writeln(y,copies(' ',9)'@{" BumpNoiz  " system "'cmd'BumpNoiz.pic"} @{" Marble   " system "'cmd'Marble.pic"} @{" BathTile " system "'cmd'BathTile.pic"} @{" Cracks   " system "'cmd'Cracks.pic"} @{" Z Buffer " system "'cmd'Z_Buffer.pic"}')
call writeln(y,copies(' ',9)'@{" ColorNoiz " system "'cmd'ColrNoiz.pic"} @{" Monster  " system "'cmd'Monster.pic"} @{" Blast    " system "'cmd'Blast.pic"} @{" DashLine " system "'cmd'DashLine.pic"} @{" BeamMeUp " system "'cmd'BeamMeUp.pic"}')
call writeln(y,copies(' ',9)'@{" Concrete  " system "'cmd'Concrete.pic"} @{" Mosaic   " system "'cmd'Mosaic.pic"} @{" BmpBrnch " system "'cmd'BmpBrnch.pic"} @{" FireBall " system "'cmd'FireBall.pic"} @{" DancSprk " system "'cmd'DancSprk.pic"}')
call writeln(y,copies(' ',9)'@{" Confetti  " system "'cmd'Confetti.pic"} @{" Pebbled  " system "'cmd'Pebbled.pic"} @{" Branches " system "'cmd'Branches.pic"} @{" GasGiant " system "'cmd'GasGiant.pic"} @{" DripDrop " system "'cmd'DripDrop.pic"}')
call writeln(y,copies(' ',9)'@{" Crumpled  " system "'cmd'Crumpled.pic"} @{" Peened   " system "'cmd'Peened.pic"} @{" Shingles " system "'cmd'Shingles.pic"} @{" HardWood " system "'cmd'HardWood.pic"} @{" Rain     " system "'cmd'Rain.pic"}')
call writeln(y,copies(' ',9)'@{" DinoSkin  " system "'cmd'DinoSkin.pic"} @{" Rainbow  " system "'cmd'Rainbow.pic"} @{" Stamped  " system "'cmd'Stamped.pic"} @{" HrdStrip " system "'cmd'HrdStrip.pic"} @{" Spark    " system "'cmd'Spark.pic"}')
call writeln(y,copies(' ',9)'@{" Dirt      " system "'cmd'Dirt.pic"} @{" Scratch  " system "'cmd'Scratch.pic"} @{" Tracer   " system "'cmd'Tracer.pic"} @{" Iris     " system "'cmd'Iris.pic"} @{" TieDye   " system "'cmd'TieDye.pic"}')
call writeln(y,copies(' ',9)'@{" DrtPaint  " system "'cmd'DrtPaint.pic"} @{" Splotch  " system "'cmd'Splotch.pic"} @{" TriChex  " system "'cmd'TriChex.pic"} @{" LensFlar " system "'cmd'LensFlar.pic"} @{" Ghost    " system "'cmd'Ghost.pic"}')
call writeln(y,copies(' ',9)'@{" EasyWood  " system "'cmd'EasyWood.pic"} @{" StainGls " system "'cmd'StainGls.pic"} @{" TriTile  " system "'cmd'TriTile.pic"} @{" Metals   " system "'cmd'Metals.pic"} @{" FogTop   " system "'cmd'FogTop.pic"}')
call writeln(y,copies(' ',9)'@{" Fakely    " system "'cmd'Fakely.pic"} @{" Statue   " system "'cmd'Statue.pic"} @{" Weave    " system "'cmd'Weave.pic"} @{" MntnTop  " system "'cmd'MntnTop.pic"} @{" FogPaint " system "'cmd'FogPaint.pic"}')
call writeln(y,copies(' ',9)'@{" FrogSkin  " system "'cmd'FrogSkin.pic"} @{" Terra    " system "'cmd'Terra.pic"} @{" Plaid    " system "'cmd'Plaid.pic"} @{" Ribbed   " system "'cmd'Ribbed.pic"} @{" Nebula   " system "'cmd'Nebula.pic"}')
call writeln(y,copies(' ',21)'@{" WormVein " system "'cmd'WormVein.pic"} @{" Antique  " system "'cmd'Antique.pic"} @{" SftStrip " system "'cmd'SftStrip.pic"}')
call endnode

/* View "Family" Sample Pics */
call node('Noiz2_View','Noiz2 Family Sample Pictures')
call writeln(y,nl||copies(' ',13)'@{"   ClrNoize2    " system "'cmd'ClrNoiz2.pic"} @{"    RefNoiz2    " system "'cmd'RefNoiz2.pic"} @{"    FilNoiz2    " system "'cmd'FilNoiz2.pic"}')
call endnode
call node('Checks_View','Checks Family Sample Pictures')
call writeln(y,nl||copies(' ',9)'@{" RectChex Texture " system "'cmd'RectChex.pic"} @{" RadCheks Texture " system "'cmd'RadCheks.pic"} @{" SprlChex Texture " system "'cmd'SprlChex.pic"}')
call endnode
call node('DeathStar_View','DeathStar Family Sample Pictures')
call writeln(y,nl||copies(' ',15)'@{" DethStar Texture " system "'cmd'DethStar.pic"}       @{" RdDthStr Texture " system "'cmd'RdDthStr.pic"}')
call endnode
call node('HoneyComb_View','HoneyComb Family Sample Pictures')
call writeln(y,nl||copies(' ',13)'@{" HonyComb Texture " system "'cmd'HonyComb.pic"} @{" Hexez Texture " system "'cmd'Hexez.pic"} @{" RadComb Texture " system "'cmd'RadComb.pic"}')
call endnode
call node('Window_View','Window Family Sample Pictures')
call writeln(y,nl||copies(' ',8)'@{" RadWind Texture " system "'cmd'RadWind.pic"} @{" RectWind Texture " system "'cmd'RectWind.pic"} @{" TubeWind Texture " system "'cmd'TubeWind.pic"}')           
call endnode

if icon='Yes' then do
  say '1B'x'[4H'center('- Creating Icon -',77)
  shell command('copy icon 'gui_path'Texture.guide.info')
end
call delete('icon')

/***** procedures & subroutines *****/

Die: /* Clean up and exit */
call close x
call close y
call Title
exit

Title:
say cls||sourceline(2)
do i = 3 to 5
  say sourceline(i)
end
call delay(60)
say
return

/* The cat is fat. The dog is with the cat. My feet are flat. */
anatine: procedure
parse arg quack
call writeln(y,'0A202020204F3C20517561636B212020'x||x2c(quack))
call writeln(y,'202A3D3D0A20205E0A'x)
return

node: procedure
parse arg node_name,node_title
node_title=strip(node_title,'L',' ')
say '1B'x'[4H'center('- 'node_title' -',77)
call writeln(y,'@node "'node_name'" "'strip(center('- 'node_title' -',67),'T',' ')'"')
return

waste: procedure /* dump blank and unwanted lines in the bit bucket */
arg count
do for count
  call readln(x)
end
return

copy_text:  /* copy text from texture.txt to Texture.guide */
wrap=''
do i= 1 to count
  if length(wrap) >max_wid then do
    line=' 'wrap
    call do_wrap
  end
  line=' 'wrap||strip(readln(x),'B','0D20'x)

  if index(line,'Requester:')>0 then do  /* separate Requester: lines */
    req_wrap=1
    if last_len<1 then call writeln(y,'')
  end
  if word(line,1)='Type:' then do
    line=line' 'strip(readln(x),'B','0D'x' ')
    i=(i+1)
  end
  else if (req_wrap) & index(line,':') >0 & length(line)>index(line,':') then do
    if last_len>1 then call writech(y,nl)
    call writeln(y,left(line,index(line,':')))
    line = ' 'strip(right(line,length(line)-index(line,':')),'L',' ')
    line = line' 'strip(readln(x),'B','0D'x' ')
    i=(i+1)
  end
  wrap=''
  if length(line) >max_wid then call do_wrap
  else call writeln(y,line)
  last_len = length(compress(line))
  if i=count then return
end

do_wrap:
new_len = lastpos(' ',line,max_wid)
wrap = right(line,(length(line)-new_len))' '
wrap_len=length(wrap)
call writeln(y,left(line,new_len-1))
return

sample: procedure /* make button to show sample pic */
parse arg picture
line=strip(readln(x),'T','0D'x)
if last_len>1 then call writeln(y,'')
call writeln(y,' @{" sample object " system "'picture'"}:')
call writech(y,' 'strip(right(line,length(line)-index(line,':')),'L',' '))
return

write_node: /* write node text to output */
parse var my_arg waste_num' 'node_txt' 'copy_num
say '1B'x'[4H'center('- 'node_txt' -',77)
pic_name=node_txt'.pic'
call waste(waste_num)
call node(node_txt,strip(readln(x),'T','0D'x))
count=copy_num ;call copy_text
call sample(show_cmd' 'pic_path||pic_name)
if node_txt='TriChex' | node_txt='TriTile' | node_txt='Antique' then,
call writeln(y,strip(readln(x),'B','0D'x' '))
else call writeln(y,'')
call endnode
return

endnode:
call writeln(y,'@endnode'nl)
req_wrap=0
return

break_c:
signal Die

syntax:
say 'Uh oh. Syntax error on line number 'SIGL
say errortext(rc)
say sourceline(SIGL)
say
say 'Call 916 899-9811 (bbs) and report the error to Dirty Duck.'
exit
